unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FontDialog1: TFontDialog;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    ReplaceDialog1: TReplaceDialog;
    FindDialog1: TFindDialog;
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FontDialog1Apply(Sender: TObject; Wnd: HWND);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button4Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     With OpenDialog1 Do
      If Execute Then
       begin
        Memo1.Lines.LoadFromFile(FileName);
        HistoryList.Add(FileName);
        Caption:= '  - '+
        ExtractFileName(FileName);
        SaveDialog1.Filename:= FileName;
        FileName:= '';
       end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     Memo1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     With SaveDialog1 Do
      If Execute Then
       begin
        Memo1.Lines.SaveToFile(FileName);
        Caption:= '  - ' +
        ExtractFileName(FileName);
       end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
     With FontDialog1 Do
      If Execute Then
      Memo1.Font:= Font;
end;

procedure TForm1.FontDialog1Apply(Sender: TObject; Wnd: HWND);
begin
     Memo1.Font:= FontDialog1.Font;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
     ReplaceDialog1.Execute;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
     FindDialog1.Execute;
end;

procedure TForm1.FindDialog1Find(Sender: TObject);
var
   Buff, P, FT: PChar;
   BuffLen: Word;
begin
     With Sender As TFindDialog Do
     begin
      GetMem(FT, Length(FindText) + 1);
      StrPCopy(FT, FindText);
      BuffLen:= Memo1.GetTextLen + 1;
      GetMem(Buff, BuffLen);
      Memo1.GetTextBuf(Buff, BuffLen);
      P:= Buff + Memo1.SelStart + Memo1.SelLength;
      P:= StrPos(P, FT);
      If P = Nil Then MessageBeep(0)
      else
      begin
       Memo1.SelStart:= P - Buff;
       Memo1.SelLength:= Length(FindText);
      end;
      FreeMem(FT, Length(FindText) + 1);
      FreeMem(Buff, BuffLen);
     end;
end;

procedure TForm1.ReplaceDialog1Replace(Sender: TObject);
begin
     With Sender As TReplaceDialog Do
      While True Do
       begin
        If Memo1.SelText <> FindText Then
        FindDialog1Find(Sender);
        If Memo1.SelLength = 0 Then Break;
        Memo1.SelText:= ReplaceText;
        If Not (frReplaceAll In Options) Then Break;
       end;
end;



end.


